package com.yiidata.mvc.annaotion;

import com.yiidata.mvc.handle.RequestMethod;

import java.lang.annotation.*;

/**
 * <pre>
 *
 * Created by zhenqin.
 * User: zhenqin
 * Date: 17/12/13
 * Time: 17:21
 * Vendor: yiidata.com
 * To change this template use File | Settings | File Templates.
 *
 * </pre>
 *
 * @author zhenqin
 */
@Inherited
@Target(ElementType.METHOD)
@Retention(RetentionPolicy.RUNTIME)
public @interface Path {

    String[] value() default "/";


    /**
     * 返回 Type
     * @return 返回 Context——Type
     */
    String contentType() default "text/html";

    /**
     * 返回内容的字符集编码
     * @return 编码字符集
     */
    String charset() default "utf-8";


    /**
     * Http 调用函数
     * @return 返回可调用的函数，默认支持POST，GET
     */
    RequestMethod[] method() default {RequestMethod.POST, RequestMethod.GET};
}
