package com.yiidata.mvc.controller;

import com.google.inject.Inject;
import com.yiidata.mvc.annaotion.Action;
import com.yiidata.mvc.annaotion.Path;
import com.yiidata.mvc.service.SimpleService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.HashMap;
import java.util.Map;

/**
 * <pre>
 *
 * Created by zhenqin.
 * User: zhenqin
 * Date: 17/12/13
 * Time: 18:02
 * Vendor: yiidata.com
 * To change this template use File | Settings | File Templates.
 *
 * </pre>
 *
 * @author zhenqin
 */
@Action
public class IndexController {



    protected SimpleService simpleService;


    /**
     * 使用 Inject 可以自动注入 simpleService 对象
     * @param simpleService
     */
    @Inject
    public IndexController(SimpleService simpleService) {
        this.simpleService = simpleService;
    }

    @Path("/")
    public String rootIndex(Map<String, Object> params, HttpServletRequest request, HttpServletResponse response) {
        return index(params, request, response);
    }


    @Path("/home")
    public String home(Map<String, Object> params, HttpServletRequest request, HttpServletResponse response) {
        return index(params, request, response);
    }


    @Path("/home.html")
    public String homeHtml(Map<String, Object> params, HttpServletRequest request, HttpServletResponse response) {
        return index(params, request, response);
    }


    @Path("/index.html")
    public String index(Map<String, Object> params, HttpServletRequest request, HttpServletResponse response) {
        HashMap<String, Object> map = new HashMap<>();
        map.put("id", "asdfasdfad");
        map.put("name", "asdfasdfad");
        map.put("nodeCount", 10);
        map.put("indexCount", 10);
        map.put("uri", "asdfasd");

        params.put("title", "Katta Overview");
        params.put("cluster", map);

        return "index.ftl";
    }

    
    /**
     * RESTFull
     * @param params
     * @return
     */
    @Path("/hi")
    public Map<String, Object> hi(Map<String, Object> params, HttpServletRequest request, HttpServletResponse response) {
        String name = request.getParameter("name");

        Map<String, Object> r = new HashMap<>();
        r.put("name", name);
        r.put("error", "我这里是中文。");
        r.put("success", true);
        r.put("datetime", System.currentTimeMillis());
        r.put("message", "hi "+name+".");

        return r;
    }


}
